#include <stdlib.h>
#include <math.h>
#include <stdio.h>

const int n=3;

void Jacobian_matrix(double* x_vect, double* J[]) {
	J[0][0]=2*x_vect[0];
	J[0][1]=2*x_vect[1];
	J[0][2]=2*x_vect[2];

	J[1][0]=4*x_vect[0];
	J[1][1]=2*x_vect[1];
	J[1][2]=-4;

	J[2][0]=6*x_vect[0];
	J[2][1]=-4;
	J[2][2]=2*x_vect[2];
}

int function_vector(double* x_vect,double* fvect) {
	fvect[0]=pow(x_vect[0],2)+pow(x_vect[1],2)+pow(x_vect[2],2)-1;
	fvect[1]=2*pow(x_vect[0],2)+pow(x_vect[1],2)-4*x_vect[2];
	fvect[2]=3*pow(x_vect[0],2)-4*x_vect[1]+pow(x_vect[2],2);

	fvect[0]=-fvect[0];
	fvect[1]=-fvect[1];
	fvect[2]=-fvect[2];
	return 0;
}

double norma(double*x) {
	return sqrt(x[1]*x[1]+x[0]*x[0]+x[2]*x[2]);
}

int main() {
	int i,j,k;
	int kolejnosc[n];
	double tmp_tab[n];
	double nowy[n];
	double fvect[n];
	double* J[n];
	double suma, wsp, tmp;
	double h[]={0,0,0};
	double x[]={0,0,0};
	int row,column;
	
	for (i = 0 ; i<n ; i++)
    		J[i]=(double*)calloc(n,sizeof(double));
		
	for (i=0 ; i<n ; i++)
		nowy[i]=x[i];

	do {
		for (i=0 ; i<n ; i++)
			x[i]=nowy[i];

		for (i=0 ; i<n ; i++)
			kolejnosc[i]=i;

		Jacobian_matrix(x,J);
		
		tmp = 0.001*(1 + norma(x));
		
		while (J[0][0]*J[1][1]*J[2][2]+J[0][1]*J[1][2]*J[2][0]+J[0][2]*J[1][0]*J[2][1]-J[0][0]*J[1][2]*J[2][1]-J[0][1]*J[1][0]*J[2][2]-J[0][2]*J[1][1]*J[2][0]==0)
			for(i=0 ; i<n ; i++)
				for(j=0 ; j<n ; j++)
					J[i][j] += tmp;

		function_vector(x,fvect);

		for ( i=0 ; i<n-1 ; i++ ) {
    			tmp=-1;
    
    			for (j=i ; j<n ; j++)
				for (k=i; k<n; k++)
	    				if (fabs(J[j][k])>tmp) {
		    				tmp=fabs(J[j][k]);
		    				row=j;
		    				column=k;
		    			}

    			for (j=0 ; j<n; j++)
		    		tmp_tab[j]=J[i][j];
    			for (j=0 ; j<n; j++)
	    			J[i][j]=J[row][j];
	    		for (j=0 ; j<n; j++)
		    		J[row][j]=tmp_tab[j];
    			tmp=fvect[row];
    			fvect[row]=fvect[i];
	    		fvect[i]=tmp;

	    		for (j=0 ; j<n; j++)
		    		tmp_tab[j]=J[j][i];
    			for (j=0 ; j<n; j++)
		    		J[j][i]=J[j][column];
    			for (j=0 ; j<n; j++)
	    			J[j][column]=tmp_tab[j];
	    		k=kolejnosc[i];
    			kolejnosc[i]=kolejnosc[column];
    			kolejnosc[column]=k;
    
    			for ( j=i+1 ; j<n ; j++ ) {
				wsp=-J[j][i]/J[i][i];
	    			for ( k=i ; k<n ; k++ )
					J[j][k]+=wsp*J[i][k];
				fvect[j]+=wsp*fvect[i];
			}
    		}	
		
		for ( i=n-1 ; i>=0 ; i-- ) {
    			suma=0;
    			for ( j=i+1 ; j<n ; j++ )
				suma+=h[j] * J[i][j];
    			h[i]=( fvect[i]-suma )/J[i][i];
    		}


		for (i=0 ; i<n ; i++)
			nowy[i]=x[i]+h[kolejnosc[i]];
	} while (x[0]!=nowy[0] || x[1]!=nowy[1] || x[2]!=nowy[2]);

	printf("Obliczony wektor x:\n");
	for (i=0 ; i<n ; i++)
		printf("%.21f\n",nowy[i]);
		
	function_vector(nowy,fvect);
	fvect[0] += 1;
	
	printf("Wartosci lewych stron rownania:\n");
	for (i=0 ; i<n ; i++)
		printf("%.21f\n",fvect[i]);

	return EXIT_SUCCESS;
}
