#include <math.h>
#include <stdio.h>
#include <stdlib.h>

const double warunek = 0.00000000001;

double f1(double x, double y) {
	return x*x+(y-1)*(y-1);
}

void grad1(double* wect) {
	double dlugosc;
	
	wect[0]=2*wect[0];
	wect[1]=2*(wect[1]-1);
	dlugosc=-sqrt(pow(wect[0],2)+pow(wect[1],2));
	wect[0]/=dlugosc;
    	wect[1]/=dlugosc;
}

double f2(double x, double y) {
	return 100*pow(x*x-y,2)+(1-x)*(1-x);
}

void grad2(double * wect) {
	double wart1=400*(pow(wect[0],2)-wect[1])*wect[0]-2*(1-wect[0]);
	double wart2=-200*(pow(wect[0],2)-wect[1]);
	double dlugosc=-sqrt(pow(wart1,2)+pow(wart2,2));
	wect[0]=wart1/dlugosc;
	wect[1]=wart2/dlugosc;
}

double f3(double x,double y) {
	return 837.9658+x*sin(sqrt(fabs(x)))+y*sin(sqrt(fabs(y)));
}

void grad3(double * wect) {
	double wart1=sin(sqrt(fabs(wect[0])))+cos(sqrt(fabs(wect[0])))*wect[0]/(2*sqrt(fabs(wect[0])));
	double wart2=sin(sqrt(fabs(wect[1])))+cos(sqrt(fabs(wect[1])))*wect[1]/(2*sqrt(fabs(wect[1])));
	double dlugosc=-sqrt(pow(wart1,2)+pow(wart2,2));
	wect[0]=wart1/dlugosc;
	wect[1]=wart2/dlugosc;
}

int main() {
	double punkt[2];
	double gradient[2];
	double nowy[2],nowy2[2],losowy[2];
	int i;
	int numer;
	double min;
	double h;
	double (*f) (double, double);
	void (*grad) (double*);
	
	printf("Wybierz funkcje: ");
	scanf("%d", &i);
	
	switch(i) {
		case 1:
			f = f1;
			grad = grad1;
			break;
		case 2:
			f = f2;
			grad = grad2;
			break;
		default:
			f = f3;
			grad = grad3;
	}
	
	printf("Podaj wspolrzedne wektora startowego: ");
	scanf("%lf %lf", &punkt[0], &punkt[1]);

	losowy[0] = losowy[1] = 0;
	numer = 2;

	do {
		gradient[0]=punkt[0];
		gradient[1]=punkt[1];
		grad(gradient);

		nowy[0]=punkt[0]-10*(gradient[0]+losowy[0]);
		nowy[1]=punkt[1]-10*(gradient[1]+losowy[1]);

		min = f(nowy[0],nowy[1]);
		for (h = -9.9 ; h<=10; h+=0.1) {
        		nowy2[0]=punkt[0]+h*(gradient[0]+losowy[0]);
        		nowy2[1]=punkt[1]+h*(gradient[1]+losowy[1]);
    			if (min > f(nowy2[0],nowy2[1])) {
            			nowy[0]=nowy2[0];
				nowy[1]=nowy2[1];
            			min = f(nowy[0],nowy[1]);
            		}
    		}

		if (f(punkt[0],punkt[1]+gradient[1])<min) {
			nowy[0]=punkt[0];nowy[1]=punkt[1]+gradient[1];}
		else if (f(punkt[0]+gradient[0],punkt[1])<min) {
			nowy[1]=punkt[1];
			nowy[0]=punkt[0]+gradient[0];
		}

		printf("f(%20.20f, %20.20f) = %20.20f\n", punkt[0], punkt[1], f(punkt[0], punkt[1]));
		printf("grad(%20.20f, %20.20f) = (%20.20f, %20.20f)\n", punkt[0], punkt[1], gradient[0], gradient[1]);
		printf("nowy wektor: (%20.20f , %20.20f)\n\n", nowy[0], nowy[1], f(nowy[0], nowy[1]));

		if (sqrt(pow(nowy[0]-punkt[0],2)+pow(nowy[1]-punkt[1],2))<warunek)
			break;

		if (f(punkt[0],punkt[1])<f(nowy[0],nowy[1])) {
    			numer++;
    			if (numer>50)
				break;
    			for (i = 0 ; i<2 ; i++)
         			losowy[i]=(rand()%10-5)/numer;
    		} else {
    			numer=2;
    			punkt[0]=nowy[0];
    			punkt[1]=nowy[1];
    			losowy[0] = losowy[1] = 0;
    		}
	} while (1);
	
	if (f(nowy[0],nowy[1])<f(punkt[0],punkt[1])) {
		punkt[0]=nowy[0];
		punkt[1]=nowy[1];
	}
	
	printf("ROZWIAZANIE: (%20.20f, %20.20f)\n", punkt[0], punkt[1]);

	return EXIT_SUCCESS;
}
